Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.net
Class SocketImpl

    java.lang.Object
      |
      +--java.net.SocketImpl

All Implemented Interfaces:
  SocketOptions

public abstract class SocketImpl
extends Object
implements SocketOptions

The abstract class `SocketImpl` is a common superclass of all classes that actually implement sockets. It is used to create both client and server sockets.

A "plain" socket implements these methods exactly as described, without attempting to go through a firewall or proxy.

Since:
  JDK1.0

Field Summary
`protected InetAddress` | `address` The IP address of the remote end of this socket.
`protected FileDescriptor` | `fd` The file descriptor object for this socket.
`protected int` | `localport` The local port number to which this socket is connected.
`protected int` | `port` The port number on the remote host to which this socket is connected.

Fields inherited from interface java.net.SocketOptions
`IP_MULTICAST_IF, SO_BINDADDR, SO_KEEPALIVE, SO_LINGER, SO_RCVBUF, SO_REUSEADDR, SO_SNDBUF, SO_TIMEOUT, TCP_NODELAY`

Constructor Summary
`SocketImpl()`

Method Summary
`protected abstract void` | `accept(SocketImpl s)` Accepts a connection.
`protected abstract int` | `available()` Returns the number of bytes that can be read from this socket without blocking.
`protected abstract void` | `bind(InetAddress host, int port)` Binds this socket to the specified port number on the specified host.
`protected abstract void` | `close()` Closes this socket.
`protected abstract void` | `connect(InetAddress address, int port)` Connects this socket to the specified port number on the specified host.
`protected abstract void` | `connect(String host, int port)` Connects this socket to the specified port on the named host.
`protected abstract void` | `create(boolean stream)` Creates either a stream or a datagram socket.
`protected FileDescriptor` | `getFileDescriptor()` Returns the value of this socket's `fd` field.
`protected InetAddress` | `getInetAddress()` Returns the value of this socket's `address` field.
`protected abstract InputStream` | `getInputStream()` Returns an input stream for this socket.
`protected int` | `getLocalPort()` Returns the value of this socket's `localport` field.
`protected abstract OutputStream` | `getOutputStream()` Returns an output stream for this socket.
`protected int` | `getPort()` Returns the value of this socket's `port` field.
`protected abstract void` | `listen(int backlog)` Sets the maximum queue length for incoming connection indications (a request to connect) to the `count` argument.
`protected void` | `shutdownInput()` Places the input stream for this socket at "end of stream".
`protected void` | `shutdownOutput()` Disables the output stream for this socket.
`String` | `toString()` Returns the address and port of this socket as a `String`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.net.SocketOptions
`getOption, setOption`

Field Detail

### fd

    protected FileDescriptor fd

  The file descriptor object for this socket.

### address

    protected InetAddress address

  The IP address of the remote end of this socket.

### port

    protected int port

  The port number on the remote host to which this socket is connected.

### localport

    protected int localport

  The local port number to which this socket is connected.

Constructor Detail

### SocketImpl

    public SocketImpl()

Method Detail

### create

    protected abstract void create(boolean stream)
                            throws IOException

  Creates either a stream or a datagram socket.
  Parameters:
    `stream` - if `true`, create a stream socket; otherwise, create a datagram socket.
  Throws:
    `IOException` - if an I/O error occurs while creating the socket.

### connect

    protected abstract void connect(String host,
                                    int port)
                             throws IOException

  Connects this socket to the specified port on the named host.
  Parameters:
    `host` - the name of the remote host.
    `port` - the port number.
  Throws:
    `IOException` - if an I/O error occurs when connecting to the remote host.

### connect

    protected abstract void connect(InetAddress address,
                                    int port)
                             throws IOException

  Connects this socket to the specified port number on the specified host.
  Parameters:
    `address` - the IP address of the remote host.
    `port` - the port number.
  Throws:
    `IOException` - if an I/O error occurs when attempting a connection.

### bind

    protected abstract void bind(InetAddress host,
                                 int port)
                          throws IOException

  Binds this socket to the specified port number on the specified host.
  Parameters:
    `host` - the IP address of the remote host.
    `port` - the port number.
  Throws:
    `IOException` - if an I/O error occurs when binding this socket.

### listen

    protected abstract void listen(int backlog)
                            throws IOException

  Sets the maximum queue length for incoming connection indications (a request to connect) to the `count` argument. If a connection indication arrives when the queue is full, the connection is refused.
  Parameters:
    `backlog` - the maximum length of the queue.
  Throws:
    `IOException` - if an I/O error occurs when creating the queue.

### accept

    protected abstract void accept(SocketImpl s)
                            throws IOException

  Accepts a connection.
  Parameters:
    `s` - the accepted connection.
  Throws:
    `IOException` - if an I/O error occurs when accepting the connection.

### getInputStream

    protected abstract InputStream getInputStream()
                                           throws IOException

  Returns an input stream for this socket.
  Returns:
    a stream for reading from this socket.
  Throws:
    `IOException` - if an I/O error occurs when creating the input stream.

### getOutputStream

    protected abstract OutputStream getOutputStream()
                                             throws IOException

  Returns an output stream for this socket.
  Returns:
    an output stream for writing to this socket.
  Throws:
    `IOException` - if an I/O error occurs when creating the output stream.

### available

    protected abstract int available()
                              throws IOException

  Returns the number of bytes that can be read from this socket without blocking.
  Returns:
    the number of bytes that can be read from this socket without blocking.
  Throws:
    `IOException` - if an I/O error occurs when determining the number of bytes available.

### close

    protected abstract void close()
                           throws IOException

  Closes this socket.
  Throws:
    `IOException` - if an I/O error occurs when closing this socket.

### shutdownInput

    protected void shutdownInput()
                          throws IOException

  Places the input stream for this socket at "end of stream". Any data sent to this socket is acknowledged and then silently discarded. If you read from a socket input stream after invoking shutdownInput() on the socket, the stream will return EOF.
  Throws:
    `IOException` - if an I/O error occurs when shutting down this socket.
  See Also:
    `Socket.shutdownOutput()`, `Socket.close()`, `Socket.setSoLinger(boolean, int)`

### shutdownOutput

    protected void shutdownOutput()
                           throws IOException

  Disables the output stream for this socket. For a TCP socket, any previously written data will be sent followed by TCP's normal connection termination sequence. If you write to a socket output stream after invoking shutdownOutput() on the socket, the stream will throw an IOException.
  Throws:
    `IOException` - if an I/O error occurs when shutting down this socket.
  See Also:
    `Socket.shutdownInput()`, `Socket.close()`, `Socket.setSoLinger(boolean, int)`

### getFileDescriptor

    protected FileDescriptor getFileDescriptor()

  Returns the value of this socket's `fd` field.
  Returns:
    the value of this socket's `fd` field.
  See Also:
    `fd`

### getInetAddress

    protected InetAddress getInetAddress()

  Returns the value of this socket's `address` field.
  Returns:
    the value of this socket's `address` field.
  See Also:
    `address`

### getPort

    protected int getPort()

  Returns the value of this socket's `port` field.
  Returns:
    the value of this socket's `port` field.
  See Also:
    `port`

### getLocalPort

    protected int getLocalPort()

  Returns the value of this socket's `localport` field.
  Returns:
    the value of this socket's `localport` field.
  See Also:
    `localport`

### toString

    public String toString()

  Returns the address and port of this socket as a `String`.
  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this socket.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >